#include <bits/stdc++.h>
using namespace std;
#ifdef SEREGA
auto _fr_ = freopen("input.txt", "r", stdin);
#endif
//template <class T>
//using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
vector<vector<int>> g;
int n, m, k;
vector<int> solve5000(const vector<pair<int, int>> &edges, const vector<pair<int, int>> &guards) {
    set<int> pre_answer;
    g.assign(n + 1, {});
    for (int i = 0; i < m; ++i) {
        int a = edges[i].first, b = edges[i].second;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    for (int i = 0; i < k; ++i) {
        int p = guards[i].first, h = guards[i].second;
        vector<int> dist(n + 1, INT_MAX);
        dist[p] = 0;
        queue<int> q;
        q.push(p);
        while (!q.empty()) {
            int v = q.front();
            q.pop();
            pre_answer.insert(v);
            for (int u : g[v]) {
                if (dist[u] == INT_MAX && dist[v] + 1 <= h) {
                    dist[u] = dist[v] + 1;
                    if (dist[v] + 1 == h) {
                        pre_answer.insert(u);
                    } else {
                        q.push(u);
                    }
                }
            }
        }
    }
    vector<int> answer(pre_answer.begin(), pre_answer.end());
    return answer;
}
vector<bool> used;
pair<int, int> diameter(int x, int p = -1) {
    used[x] = true;
    pair<int, int> answer = {1, x};
    for (int u : g[x]) {
        if (!used[u]) {
            pair<int, int> child = diameter(u, x);
            if (child.first + 1 > answer.first) {
                answer = child;
                answer.first++;
            }
        }
    }
    return answer;
}
vector<int> old_to_new, new_to_old;
void rearrange(int x, int p = -1, int timer = 1) {
    used[x] = true;
    old_to_new[x] = timer;
    new_to_old[timer] = x;
    for (int u : g[x]) {
        if (!used[u]) {
            rearrange(u, x, timer + 1);
        }
    }
}

vector<int> solvebamboo(const vector<pair<int, int>> &edges, const vector<pair<int, int>> &guards) {
    g.assign(n + 1, {});
    old_to_new.assign(n + 1, {});
    new_to_old.assign(n + 1, {});
    for (int i =0 ; i < m; ++i) {
        int a = edges[i].first, b = edges[i].second;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    used.assign(n + 1, {});
    pair<int, int> first = diameter(1);
    used.assign(n + 1, {});
    rearrange(first.second);
    vector<int> ranges(n + 2);
    for (int i = 0; i < k; ++i) {
        int p = guards[i].first, h = guards[i].second;
        ranges[max<int>(1, old_to_new[p] - h)] += 1;
        ranges[min(n + 1, old_to_new[p] + h + 1)] += -1;
    }
    int ssf = 0;
    vector<int> answer;
    for (int i = 1; i <= n; ++i) {
        ssf += ranges[i];
        if (ssf > 0) {
            answer.push_back(new_to_old[i]);
        }
    }
    sort(answer.begin(), answer.end());
    return answer;
}
signed main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    cin >> n >> m >> k;
    vector<pair<int, int>> edges(m), guards(k);
    for (int i = 0; i < m; ++i) {
        cin >> edges[i].first >> edges[i].second;
    }
    for (int i = 0; i < k; ++i) {
        cin >> guards[i].first >> guards[i].second;
    }
    vector<int> answer = (n <= 5000) ? solve5000(edges, guards) : solvebamboo(edges, guards);
    cout << answer.size() << endl;
    for (int i : answer) cout << i << ' ';
    cout<< endl;
    return 0;
    mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
    #define uid(x, y) uniform_int_distribution<int>(x,y)(rng)
    int tc = 0;
    while (true) {
        cout << tc++ << endl;
        n = uid(1, 100);
        m = n - 1;
        k = uid(1, n);
        vector<int> bamboo(n);
        iota(bamboo.begin(), bamboo.end(), 1);
        shuffle(bamboo.begin(), bamboo.end(), rng);
        vector<pair<int, int>> edges(m);
        for (int i = 1; i < n; ++i) {
            edges[i - 1] = pair<int, int>{bamboo[i - 1], bamboo[i]};
        }
        vector<pair<int, int>> guards(k);
        for (int i = 0; i < k; ++i) {
            guards[i] = {uid(1, n), uid(1, n)};
        }
        if (solve5000(edges, guards) != solvebamboo(edges, guards)) {
            cout << n << ' ' << m << ' ' << k << endl;
            for (auto [u, v] : edges) {
                cout << u << ' ' << v << endl;
            }
            for (auto &[u, v] : guards) {
                cout << u << ' ' << v << endl;
            }
            exit(0);
        }

    }
    return 0;
}
