#include <bits/stdc++.h>
using namespace std;
#define int int64_t
#ifdef SEREGA
auto _fr_ = freopen("input.txt", "r", stdin);
#endif
//template <class T>
//using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

struct pt {
    int x, y;
    double dist(const pt &l) {
        return sqrt((x - l.x) * (x - l.x) + (y - l.y) * (y - l.y));
    }
    double len() {
        return sqrt(x*x+y*y);
    }
    double sqrlen() {
        return (x*x+y*y);
    }

    pt operator+(const pt &l) {
        return {x + l.x, y + l.y};
    }
    int vecmul(const pt &l) {
        return x*l.y - y*l.x;
    }
    int scalmul(const pt &l) {
        return x * l.x + y * l.y;
    }
    pt& operator+=(const pt &l) {
        x += l.x;
        y += l.y;
        return *this;
    }
};

istream &operator>>(istream& in, pt &l) {
    in >> l.x >> l.y;
    return in;
}
pt Ox = {1, 0};
int n;
vector<pt> points;

double getdist(int i, int j, double alpha) {
    if (points[i].y > points[j].y) swap(i, j);
    pt vec = {points[j].x - points[i].x, points[j].y - points[i].y};
    double beta = atan2(Ox.vecmul(vec), Ox.scalmul(vec));
    double sinphi = sin(alpha) * cos(beta) - sin(beta)*cos(alpha);
    swap(alpha, beta);
    sinphi = max(sinphi, sin(alpha) * cos(beta) - sin(beta)*cos(alpha));
    double dist = vec.len();
    double katet = dist * sinphi;
    double sqrdist = vec.sqrlen();
    double another = sqrt(sqrdist - sqrdist * sinphi * sinphi);
//    cout << i + 1 << ' ' << j + 1 << ' ' << katet + another << endl;
    return katet + another;
}

double f(double angle) {
    vector<vector<double>> dp(1<<n,vector<double>(n, 1e18));
    for (int i = 0; i < n; ++i) {
        dp[1 << i][i] = 0;
    }
    for (int mask = 0; mask < 1 << n; ++mask) {
        for (int i = 0; i < n; ++i) {
            if (dp[mask][i] == 1e18) continue;
            for (int j = 0; j < n; ++j) {
                if (mask >> j & 1) continue;
                double dist = getdist(i, j, angle);
                dp[mask | (1 << j)][j] = min(dp[mask | (1 << j)][j], dp[mask][i] + dist);
            }
        }
    }
    double answer = LLONG_MAX;
    for (int i = 0; i < n; ++i) {
        answer = min(answer, dp[(1<<n)-1][i]);
    }
    return answer;
}

double solve_fast() {
    double l = -1, r = 2 * M_PI + 1;
    double EPS = 1e-11;
    while (r - l > EPS) {
        double m1 = l + (r - l) / 3;
        double m2 = r - (r - l) / 3;
        if (f(m1) < f(m2)) {
            r = m2;
        } else {
            l = m1;
        }
    }
    return f(l);
}
double solve_slow() {
    return sqrt((points[0].x - points[1].x)*(points[0].x - points[1].x)+ (points[0].y - points[1].y)*(points[0].y - points[1].y));
}


signed main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    cout << setprecision(20);
    cin >> n;
    points.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> points[i];
    }
    cout << solve_fast() << endl;
//    cout << solve_slow() << endl;
//    mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
//    const double EPS = 1e-6;
//    points.resize(2);
//    #define uid(x,y) uniform_int_distribution<int>(x, y)(rng)
//    while (true) {
//        n = 2;
//        points[0] = pt{uid(-1000, 10000), uid(-10000, 10000)};
//        points[1] = pt{uid(-1000, 10000), uid(-10000, 10000)};
//        if (abs(solve_fast() - solve_slow()) > EPS) {
//            cout << points[0].x << ' ' << points[0].y << endl;
//            cout << points[1].x << ' ' << points[1].y << endl;
//            return 0;
//        }
//    }
    return 0;
}
