#include <bits/stdc++.h>
using namespace std;
#define double long double
#ifdef SEREGA
auto _fr_ = freopen("input.txt", "r", stdin);
#endif
//template <class T>
//using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

struct pt {
    int x, y;
    double dist(const pt &l) {
        return sqrt((x - l.x) * (x - l.x) + (y - l.y) * (y - l.y));
    }
    double len() {
        return sqrt(x*x+y*y);
    }
    pt operator+(const pt &l) {
        return {x + l.x, y + l.y};
    }
    int vecmul(const pt &l) {
        return x*l.y - y*l.x;
    }
    int scalmul(const pt &l) {
        return x * l.x + y * l.y;
    }
    pt& operator+=(const pt &l) {
        x += l.x;
        y += l.y;
        return *this;
    }
};

istream &operator>>(istream& in, pt &l) {
    in >> l.x >> l.y;
    return in;
}
pt Ox = {1, 0};
int n;
vector<pt> points;

double getdist(int i, int j, double alpha) {
    if (points[i].y > points[j].y) swap(i, j);
    pt vec = {points[j].x - points[i].x, points[j].y - points[i].y};
    double beta = atan2l(Ox.vecmul(vec), Ox.scalmul(vec));
    double sinphi = sinl(alpha) * cosl(beta) - sinl(beta)*cosl(alpha);
    swap(alpha, beta);
    sinphi = max(sinphi, sinl(alpha) * cosl(beta) - sinl(beta)*cosl(alpha));
    double dist = vec.len();
    double katet = dist * sinphi;
    double another = sqrt(dist * dist - katet * katet);
//    cout << i + 1 << ' ' << j + 1 << ' ' << katet + another << endl;
    return katet + another;
}

double f(double angle) {
    vector<vector<double>> dp(1<<n,vector<double>(n, INT_MAX));
    for (int i = 0; i < n; ++i) {
        dp[1 << i][i] = 0;
    }
    for (int mask = 0; mask < 1 << n; ++mask) {
        for (int i = 0; i < n; ++i) {
            if (dp[mask][i] == INT_MAX) continue;
            for (int j = 0; j < n; ++j) {
                if (mask >> j & 1) continue;
                double dist = getdist(i, j, angle);
                dp[mask | (1 << j)][j] = min(dp[mask | (1 << j)][j], dp[mask][i] + dist);
            }
        }
    }
    double answer = INT_MAX;
    for (int i = 0; i < n; ++i) {
        answer = min(answer, dp[(1<<n)-1][i]);
    }
    return answer;
}

void solve() {
    cin >> n;
    points.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> points[i];
    }
    double l = 0, r = 2 * M_PI;
    for (int i = 0; i < 4000; ++i) {
        double m1 = l + (r - l) / 3;
        double m2 = r - (r - l) / 3;
        if (f(m1) < f(m2)) {
            r = m2;
        } else {
            l = m1;
        }
    }
//    cout << l << endl;
    cout << f(l) << endl;
}

signed main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    cout << setprecision(20);
    solve();
    return 0;
}
